import sqlite3
import hashlib
from random import choice

SALT_CHARS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-1234567890.,;:"

def make_connection():
    return sqlite3.connect("database.sqlite")

def create_user(name, password):
    conn = make_connection()
    salt = ""
    for i in range(15):
        salt += choice(SALT_CHARS)
    salt_password = password + salt
    password_hash = hashlib.md5(salt_password.encode("utf-8"))
    password_hash = password_hash.hexdigest()
    print(f"Создаём пользователя {name}")
    print(f"Пароль: {password}")
    print(f"Соль:   {salt}")
    print(f"Хэш:    {password_hash}")
    csr = conn.cursor()
    sql = "INSERT INTO \"User\" (username, salt, password_hash) VALUES (?, ?, ?)"
    csr.execute(sql, (name, salt, password_hash))
    conn.commit()

def authorize_user(name, password):
    conn = make_connection()
    sql = "SELECT username, password_hash, salt FROM \"User\" WHERE username=?"
    csr = conn.cursor()
    csr.execute(sql, (name,))
    row = csr.fetchone() # Возвращает следующую строку результата, или None если там пусто
    if row != None:
        username, password_hash, salt = row
        salt_password_2 = password + salt
        password_hash_2 = hashlib.md5(salt_password_2.encode("utf-8"))
        password_hash_2 = password_hash_2.hexdigest()
        if password_hash_2 == password_hash:
            return True
    return False

def authenticate_user(name):
    conn = make_connection()
    sql = "SELECT username FROM \"User\" WHERE username=?"
    csr = conn.cursor()
    csr.execute(sql, (name,))
    row = csr.fetchone()
    if row:
        return True
    return False